import kcs_ui
import kcs_pipe
import kcs_dex
import KcsPoint3D
import kcs_util
import os
import datetime
import math
import string
import KcsModel
import KcsPoint2D
import kcs_draft
from wxPython.wx import *
import os, types
import KcsPipeName   #		This statement is added to work with TRIBON M3 On  5th- 9th may 2008 		 


class DemoApp(wxApp):
        def OnInit(self):
            wxImage_AddHandler(wxJPEGHandler())
            wxImage_AddHandler(wxPNGHandler())
            wxImage_AddHandler(wxGIFHandler())
            return true


								# All Window Function Definitions
#**********************************************************************************************************************

#								 *** window-1 Function ***

def select_choice(fun_no,choice1_str,choice2_str,array=None):
	frame = wxFrame(NULL, 2400, "Select", size=(250,150),style=wxMINIMIZE_BOX |  wxSYSTEM_MENU | wxCAPTION)
	frame.Centre(wxBOTH)
	panel = wxPanel (frame,id= -1,size=(50,50))
	check1=wxCheckBox(panel,-1,choice1_str,pos=(20,20))
	check2=wxCheckBox(panel,-1,choice2_str,pos=(20,50))
	botton1=wxButton(panel,-1,"Ok",pos=(20,80))
	botton2=wxButton(panel,-1,"Cancel",pos=(130,80))
	check1.SetValue(True)

	def check1_event(event):
		if(check1.GetValue()):
			check2.SetValue(False)
		else:
			check2.SetValue(True)

	def check2_event(event):
		if(check2.GetValue()):
			check1.SetValue(False)
		else:
			check1.SetValue(True)

	def cancel_event(event):
		frame.Show(False)
		frame.Destroy()

	def temp_event(event):
		panel.Show(False)
		frame.Destroy()

	def ok_event(event):
		if(check1.GetValue()):
			
			
			if fun_no==1:
				cancel_event(event)
				through_system_names_main()
			else:
				temp_event(event)

				dlg = wxFileDialog(NULL,"Choose a file", "", "", "*.n", wxOPEN)
				if dlg.ShowModal() == wxID_OK:
					neutral_file_path=dlg.GetPath()
					Main(array,1,neutral_file_path)
					
		else:			
			if fun_no==1:
				cancel_event(event)	
				through_graphics_main()
			else:
				temp_event(event)

				dlg= wxDirDialog(NULL)
				if dlg.ShowModal() == wxID_OK:
					neutral_file_path=dlg.GetPath()
					Main(array,2,neutral_file_path)

	EVT_CHECKBOX(panel,check1.GetId(), check1_event)
	EVT_CHECKBOX(panel,check2.GetId(), check2_event)
	EVT_BUTTON(panel,botton1.GetId(), ok_event)
	EVT_BUTTON(panel,botton2.GetId(), cancel_event)

	frame.Show()



#								 *** window-1 Function ***

def select_string(fun_no,title,list):

	def cancel_button_event(event):
		frame.Show(False)
		frame.Destroy()
		
	def temp_event(event):
		panel.Show(False)
		frame.Destroy()

 	def all_button_event(event):
		number_items=multi_listbox.GetCount()
		for i in range(number_items):
			multi_listbox.SetSelection(i)

	def none_button_event(event):
		number_items=multi_listbox.GetCount()
		for i in range(number_items):
			multi_listbox.SetSelection(i,False)

	def ok_button_event(event):
		number_items=multi_listbox.GetCount()
		selected_list=[]
		for i in range(number_items):
			if (multi_listbox.Selected(i)) :
				selected_list.append(multi_listbox.GetString(i))
		
		if len(selected_list) > 0:
			if fun_no==1:
				cancel_button_event(event)
				pipeline_name_array_for_selection=Get_pipelines_by_system_names(selected_list)
				select_string(2,"Select Pipeline Names",pipeline_name_array_for_selection)
			else:
				
				if len(selected_list) == 1:
					temp_event(event)
				else:	
					cancel_button_event(event)
				selected_pipelines_main(selected_list)

	frame = wxFrame(NULL, 2400,title, size=(350,420),style=
                    wxMINIMIZE_BOX |  wxSYSTEM_MENU | wxCAPTION)
	frame.Centre(wxBOTH)
	panel = wxPanel (frame,id= -1)
	multi_listbox=wxListBox(panel,-1,pos=(0,0),size=(350,360),choices=list,style=wxLB_MULTIPLE)
	ok_button=wxButton(panel,-1,"Ok",pos=(20,370))
	all_button=wxButton(panel,-1,"All",pos=(100,370))

	none_button=wxButton(panel,-1,"None",pos=(180,370))
	cancel_button=wxButton(panel,-1,"Cancel",pos=(260,370))
            
	EVT_BUTTON(panel,ok_button.GetId(),ok_button_event)
	EVT_BUTTON(panel,all_button.GetId(),all_button_event)
	EVT_BUTTON(panel,none_button.GetId(),none_button_event)
	EVT_BUTTON(panel,cancel_button.GetId(),cancel_button_event)
	frame.Show()

        
							# Main function Definition
#**********************************************************************************************************************
def selected_pipelines_main(selected_pipeline_name_array):
	
	number_of_selected_pipelines=len(selected_pipeline_name_array)
	if number_of_selected_pipelines==1:
		number_of_neutral_files=2
		dlg= wxDirDialog(NULL)
		if dlg.ShowModal() == wxID_OK:
			neutral_file_path=dlg.GetPath()
			Main(selected_pipeline_name_array,number_of_neutral_files,neutral_file_path)
	else:
		choice1_str="Single Neutral File"
		choice2_str="Multi Neutral File"
		select_choice(2,choice1_str,choice2_str,selected_pipeline_name_array)

#								 *** Main Function ***

def Main(selected_pipeline_name_array,number_of_neutral_files,neutral_file_path):
	wxBeginBusyCursor()
	number_of_selected_pipelines=len(selected_pipeline_name_array)
	Get_Cancel_Pipe()					# Sub-4 Function

	if number_of_neutral_files == 2:
		for i in range(number_of_selected_pipelines):
			final_node_numbers=[900,0,950]
			result=Get_main_for_multi_neutral_file(selected_pipeline_name_array[i],neutral_file_path ,final_node_numbers)					# Sub-5 Function

			Get_Cancel_Pipe()			# Sub-4 Function

	else:
		final_node_numbers=[900,0,950]
		res,f=file_create(neutral_file_path,'model','subsystem')						# Sub-8 Function
		if res == 0 :
			return 0

		spec_names_array=[[],[]]
		loadset_array=[[],[],[],[],[]]
		i=0
		for i in range(number_of_selected_pipelines):
			partids_array=Get_partids_Array_of_Selected_PipeLine(selected_pipeline_name_array[i]) # Sub-6 Function
			if len(partids_array) != 0:
				spec_names_array=Get_spec_names_of_Selected_PipeLine(selected_pipeline_name_array[i],partids_array, spec_names_array)															# Sub-7 Function
			Get_Cancel_Pipe()												# Sub-4 Function

		loadset_array=write_loadset_details(f,spec_names_array,loadset_array)				# Sub-9 Function
		f.write(" CODE,CODE0,B31.1,2001\n")
		node_array=[[],[],[],[]]

		j=0
		for j in range(number_of_selected_pipelines):
			partids_array=Get_partids_Array_of_Selected_PipeLine(selected_pipeline_name_array[j]) # Sub-6 Function
			if len(partids_array) != 0:
				for part_id in partids_array:
					segment_id=Get_Loadset_id(selected_pipeline_name_array[j],part_id,loadset_array)
																	# Sub-10 Function
					no_comps,no_conns,short_code,comp_id1,spec,comp_name_db,conn_ids_array,node_array = Get_comp_main_details(selected_pipeline_name_array[j],part_id,node_array,final_node_numbers)		# Sub-11 Function

					for s in range(no_comps) :
						comp_id=comp_id1+str(s)
						conn_ids_str=conn_ids_array[s]
						line_1(f,short_code,comp_id,spec,conn_ids_str)				# Sub-15 Function
						line_2(f,short_code,comp_id,comp_name_db,1)				# Sub-16 Function
						line_3(f,short_code,comp_id,comp_name_db,conn_ids_str,node_array)	# Sub-17 Function
						for conn in range(no_conns):
							line_conn(f,short_code,comp_id,comp_name_db,conn,segment_id)# Sub-19 Function
			Get_Cancel_Pipe()											# Sub-4 Function

		for k in range(len(node_array[0])):
			p=0.0
			str1=' MNODE,%6d,%15s,%15s,%15s,   2,%10.2f'%(node_array[0][k],node_array[1][k],node_array[2][k],node_array[3][k],p)
			f.write(str1 + "\n")

		del node_array
		f.close()

	wxEndBusyCursor()
	kcs_ui.message_confirm("Transfered Successfully")
	return 0


#**********************************************************************************************************************


def through_system_names_main():
		# Getting Model Names from Project    <Module>-<System><PipeNo>
	pipe_model_name_array=[]
	dexstring="PIPE.PIPMODEL(*).NAME"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	while type >= 0:
		if type ==3:
			pipe_model_name_array.append(kcs_dex.get_string())
		type = kcs_dex.next_result()
	
	system_name_array=[]
	for model_name in pipe_model_name_array:
		module_name,pipe_name=model_name.split("-")
		i=0

		while i < len(pipe_name):
			q=pipe_name[i]
        		try:
				q_int=int(q)
				system_name=pipe_name[:i]
				exist=system_name_array.count(system_name)
				if exist == 0 :
					system_name_array.append(system_name)
				i=len(pipe_name)
			except:
				i=i+1
	del pipe_model_name_array
	if len(system_name_array) > 0:
		select_string(1,"Select System Names",system_name_array)
	

def through_graphics_main():
	pipeline_name_array_for_selection=[]
	con=1
	while con==1:
		pt = KcsPoint2D.Point2D()
		kcs_ui.point2D_req("Indicate part", pt)
		ModelInfo = KcsModel.Model()
		try:
			kcs_draft.model_identify(pt, ModelInfo)
			if ModelInfo.Type in ["pipe"]:
				exist=pipeline_name_array_for_selection.count(ModelInfo.Name)
				if exist == 0:
					pipeline_name_array_for_selection.append(ModelInfo.Name)
		except:
			print kcs_draft.error
		title="Select"
		question="Do you want to continue with Selection? "
		res=kcs_ui.answer_req(title, question)
		if res != kcs_util.yes():
			con=0
	if len(pipeline_name_array_for_selection) > 0:
		select_string(2,"Select Pipeline Names",pipeline_name_array_for_selection)

								# All Subfunctions Definitions
#**********************************************************************************************************************

#								 *** Sub-2 Function ***

def Get_pipelines_by_system_names(selected_system_name_array):
		# Getting Model Names from Project    <Module>-<System><PipeNo>
	pipe_model_name_array=[]
	dexstring="PIPE.PIPMODEL(*).NAME"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	while type >= 0:
		if type ==3:
			pipe_model_name_array.append(kcs_dex.get_string())
		type = kcs_dex.next_result()

			# Getting Pipeline Names from Project  <Project>-<Module>-<System><PipeNo>

	project_name=kcs_util.TB_environment_get('SB_PROJ_PIPE')
	pipeline_name_array_by_system_name=[]
	for model_name in pipe_model_name_array:
		module_name,pipe_name=model_name.split("-")
		for system_name in selected_system_name_array:
			exist=string.count(pipe_name,system_name)
			if exist > 0:
				pipeline_name=project_name + "-" + model_name
				pipeline_name_array_by_system_name.append(pipeline_name)

	return pipeline_name_array_by_system_name


#								 *** Sub-4 Function ***

def Get_Cancel_Pipe():
	p_name=""
	try:
		p_name=kcs_pipe.pipe_name_get()
	except:
		print "error"

	if p_name != "":
		result, spool_id = kcs_pipe.pipe_spool_find(1)
		result, part_id  = kcs_pipe.pipe_spool_part_find(1, spool_id)
		point=KcsPoint3D.Point3D()
		conn_cordinates=kcs_pipe.part_conn_coord_get(part_id,1,point)
		kcs_pipe.pipe_cancel()


#								 *** Sub-5 Function ***

def Get_main_for_multi_neutral_file(selected_pipeline_name,neutral_file_path,final_node_numbers):

	partids_array=Get_partids_Array_of_Selected_PipeLine(selected_pipeline_name)	# Sub-6 Function
	if len(partids_array) == 0:
		return 0

	project_name,module_name,subsystem_name=selected_pipeline_name.split("-")
	filename=neutral_file_path + "\\" + project_name + module_name + subsystem_name + ".n"
	res,f=file_create(filename,module_name,subsystem_name)					# Sub-8 Function
	if res == 0:
		return 0



	spec_names_array=[[],[]]
	spec_names_array = Get_spec_names_of_Selected_PipeLine(selected_pipeline_name,partids_array,spec_names_array)
														# Sub-7 Function
	loadset_array=[[],[],[],[],[]]
	loadset_array=write_loadset_details(f,spec_names_array,loadset_array)		# Sub-9 Function
	del spec_names_array
	f.write(" CODE,CODE0,B31.1,2001\n")

	node_array=[[],[],[],[]]
	for part_id in partids_array:

		segment_id=Get_Loadset_id(selected_pipeline_name,part_id,loadset_array)		# Sub-10 Function

		no_comps_n,no_conns,short_code_n,comp_id_n1,spec_n,comp_name_db,conn_ids_array_n,node_array_n = Get_comp_main_details(selected_pipeline_name,part_id,node_array,final_node_numbers)					
															# Sub-11 Function
		for s in range(no_comps_n) :
			comp_id_n=comp_id_n1+str(s)
			conn_ids_str=conn_ids_array_n[s]
			line_1(f,short_code_n,comp_id_n,spec_n,conn_ids_str)				# Sub-15 Function
			line_2(f,short_code_n,comp_id_n,comp_name_db,1)					# Sub-16 Function
			line_3(f,short_code_n,comp_id_n,comp_name_db,conn_ids_str,node_array_n)	# Sub-17 Function
			for conn in range(no_conns):
				line_conn(f,short_code_n,comp_id_n,comp_name_db,conn,segment_id)	# Sub-19 Function

	for k in range(len(node_array_n[0])):
		p=0.0
		str1=' MNODE,%6d,%15s,%15s,%15s,   2,%10.2f'%(node_array_n[0][k],node_array_n[1][k],node_array_n[2][k],node_array_n[3][k],p)
		f.write(str1 + "\n")
	
	f.close()

	return 0

#								 *** Sub-6 Function ***

def Get_partids_Array_of_Selected_PipeLine(pipeline_name):
	project_name,model_name=pipeline_name.split('-',1)
	partids_array=[]

	result=kcs_pipe.pipe_exist(model_name)
	if result == 0:
		return partids_array
	try:
		kcs_pipe.pipe_activate(KcsPipeName.PipeName(model_name)) #	This statement is modified  to work with TRIBON M3 On  5th- 9th may 2008 		 
	except:
		return partids_array

	result=kcs_pipe.pipe_part_find(1)
	if result[0] == 0:
		kcs_pipe.pipe_cancel()
		return partids_array
	
	result1, spool_id = kcs_pipe.pipe_spool_find(1)
	while (result1 != 0):
		result2, part_id = kcs_pipe.pipe_spool_part_find(1, spool_id)
		while (result2 != 0):
			dexstring="PIPE('" + project_name + "').PIPMODEL('" + model_name + "').PART(" + str(part_id) + ").COMP_TYPE"
			kcs_dex.extract(dexstring)
			type = kcs_dex.next_result()
			if type ==1:
				component_type=kcs_dex.get_int()
				if component_type > 0:
					partids_array.append(part_id)
			kcs_pipe.pipe_activate(KcsPipeName.PipeName(model_name))    # This statement is added to work with TRIBON M3 On  5th- 9th may 2008 		 
			result2, part_id = kcs_pipe.pipe_spool_part_find(2, part_id)
		result1, spool_id = kcs_pipe.pipe_spool_find(2, spool_id)
	return partids_array


#								 *** Sub-7 Function ***

def Get_spec_names_of_Selected_PipeLine(pipeline_name,partids_array, spec_names_array):
	
	project_name,model_name=pipeline_name.split("-",1)
	module,subsystem=model_name.split("-")

	for part_id in partids_array:
		dexstring = "PIPE('" + project_name + "').PIPM('" + model_name + "').PART(" + str(part_id) + ").SPEC_S.SPEC"
		result=kcs_dex.extract(dexstring)
		type = kcs_dex.next_result()
		if type ==3:
			spec_name=kcs_dex.get_string()

		else:
			spec_name=" "
		exist=spec_names_array[1].count(spec_name)
		if exist == 0:
			spec_names_array[0].append(subsystem)
			spec_names_array[1].append(spec_name)

	return spec_names_array

#								 *** Sub-8 Function ***




def file_create(filename,module_name,subsystem_name):
	try:
		f=file(filename,'w')
		f.write("! Model Design file(s) :" + module_name + "\n")
		f.write("! Line name(s)         :" + module_name + subsystem_name + "\n")
		f.write("! Date                 :" + datetime.datetime.now().strftime('%d-%b-%Y %H:%M:%S') + "\n")
		f.write(" AVEVA'S TRIBON MX\n")
	 	f.write(" UNITS, MM, KG\n")
		f.write(" VENDOR, INFOPLANT TECHNOLOGIES Pvt Ltd\n")
		f.write(" DRAW," + module_name + subsystem_name + "," + module_name + subsystem_name+"\n")
		return 1,f
	except:
		return 0," "

#								 *** Sub-9 Function ***

def write_loadset_details(f,spec_names_array,loadset_array):
	lset=1
	for i in range(len(spec_names_array[0])):
		spec_name=spec_names_array[1][i]
		t_min=0.0
		p_min=0.0
		t_max=100.0
		p_max=100.0
		if spec_name != " ":
			project_name=kcs_util.TB_environment_get('SB_PROJ_PIPE')
			dexstring="PIPE('" + str(project_name) + "').PSPEC('" + spec_name + "').MIN_T"
			kcs_dex.extract(dexstring)
			type = kcs_dex.next_result()
			if type ==2:
				t_min=kcs_dex.get_real()
			dexstring="PIPE('" + str(project_name) + "').PSPEC('" + spec_name + "').MIN_P"
			kcs_dex.extract(dexstring)
			type = kcs_dex.next_result()
			if type ==2:
				p_min=kcs_dex.get_real()
			dexstring="PIPE('" + str(project_name) + "').PSPEC('" + spec_name + "').MAX_T"
			kcs_dex.extract(dexstring)
			type = kcs_dex.next_result()
			if type ==2:
				t_max=kcs_dex.get_real()
			dexstring="PIPE('" + str(project_name) + "').PSPEC('" + spec_name + "').MAX_P"
			kcs_dex.extract(dexstring)
			type = kcs_dex.next_result()
			if type ==2:
				p_max=kcs_dex.get_real()

		loadset_array[0].append(str(spec_names_array[0][i])+str(lset))
		loadset_array[1].append(t_min)
		loadset_array[2].append(p_min)
		loadset_array[3].append(t_max)
		loadset_array[4].append(p_max)
		lset=lset+1

	for j in range(len(loadset_array[0])):
		l_set1='%0.2f,%0.2f'%(loadset_array[2][j],loadset_array[1][j])
		l_set2='%0.2f,%0.2f'%(loadset_array[4][j],loadset_array[3][j])		
		load_string1= " MLOAD," + str(loadset_array[0][j]) + ", 1, 3," + l_set1 + "," + l_set1 + "," + l_set1 
		load_string2= " MLOAD," + str(loadset_array[0][j]) + ", 4, 6," + l_set1 + "," + l_set1 + "," + l_set2
		load_string3= " MLSET," + str(loadset_array[0][j]) + ",3,6,5,3"
		f.write(load_string1 + "\n" + load_string2 + "\n" + load_string3 + "\n")

	return loadset_array

#								 *** Sub-10 Function ***

def Get_Loadset_id(pipeline_name,part_id,loadset_array):
	t_min=0.0
	p_min=0.0
	t_max=100.0
	p_max=100.0
	project_name,model_name=pipeline_name.split("-",1)
	dexstring = "PIPE('" + project_name + "').PIPM('" + model_name + "').PART(" + str(part_id) + ").SPEC_S.SPEC"
	result=kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type == 3:
		spec_name=kcs_dex.get_string()
		

		dexstring="PIPE('" + project_name + "').PSPEC('" + spec_name + "').MIN_T"
		kcs_dex.extract(dexstring)
		type = kcs_dex.next_result()
		if type == 2:
			t_min=kcs_dex.get_real()

		dexstring="PIPE('" + project_name + "').PSPEC('" + spec_name + "').MIN_P"
		kcs_dex.extract(dexstring)
		type = kcs_dex.next_result()
		if type == 2:
			p_min=kcs_dex.get_real()

		dexstring="PIPE('" + project_name + "').PSPEC('" + spec_name + "').MAX_T"
		kcs_dex.extract(dexstring)
		type = kcs_dex.next_result()
		if type == 2:
			t_max=kcs_dex.get_real()

		dexstring="PIPE('" + project_name + "').PSPEC('" + spec_name + "').MAX_P"
		kcs_dex.extract(dexstring)
		type = kcs_dex.next_result()
		if type == 2:
			p_max=kcs_dex.get_real()

	for i in range(len(loadset_array[0])):
		if ( (t_min == loadset_array[1][i]) & (p_min == loadset_array[2][i]) & (t_max == loadset_array[3][i]) & (p_max == loadset_array[4][i]) ):
			seg_id = str(loadset_array[0][i])

	return seg_id

#								 *** Sub-11 Function ***

def Get_comp_main_details(pipeline_name,part_id,node_array,final_node_numbers):
	project_name,model_name=pipeline_name.split("-",1)
	module,sub_system=model_name.split("-",1)
	part_id_str=str(part_id)

	comp_id_n=str(sub_system) + part_id_str[1:len(part_id_str)]

	dexstring = "PIPE('" + project_name + "').PIPM('" + model_name + "').PART(" + str(part_id) + ").SPEC_S.SPEC"
	result=kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type ==3:
		spec_name_n=kcs_dex.get_string()
	else:
		spec_name_n=" "

	dexstring="PIPE('" + project_name + "').PIPMODEL('" + model_name + "').PART(" + str(part_id) + ").COMP_NAME"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type ==3:
		component_name_db=kcs_dex.get_string()
	else:
		component_name_db=" "

	dexstring="PIPE('" + project_name + "').PIPMODEL('" + model_name + "').PART(" + str(part_id) + ").COMP_TYPE"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type ==1:
		component_type=kcs_dex.get_int()
	else:

		component_type=0


	dexstring="PIPE('" + project_name + "').PIPMODEL('" + model_name + "').PART(" + str(part_id) + ").PART_TYPE"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type ==1:
		part_type=kcs_dex.get_int()
	else:
		part_type=0
	no_comps_n,short_code_n=Get_comp_code(component_type,part_type)				# Sub-12 Function

	no_conns,conn_ids_array_n,node_array=Get_conn_details(pipeline_name,part_id,component_type,part_type,node_array, final_node_numbers)
															# Sub-13 Function

	return no_comps_n,no_conns,short_code_n,comp_id_n,spec_name_n,component_name_db,conn_ids_array_n,node_array

#								 *** Sub-12 Function ***

def Get_comp_code(comp_type,part_type):
	comp_type_str=str(comp_type)
	if comp_type_str == "1206":
		return 1,"RD"
	elif comp_type_str == "1501":
		return 1,"ER"
	elif comp_type_str == "1522":
		return 2,"EL"
	elif comp_type_str[0]=="2":
		return 1,"FL"
	elif ((comp_type_str[0]=="7") & (part_type == 4)):
		return 1,"EL"
	elif (comp_type_str[0]=="7") | (comp_type_str[0:2]=="41") | (comp_type_str[0:2]=="43"):
		return 1,"PI"
	elif (comp_type_str[0:2] == "82") | (comp_type_str[0:2] == "85") | (comp_type_str[0:2] == "11") | (comp_type_str[0:3] == "120") | (comp_type_str[0:2] == "31"):
		return 1,"RB"
	elif comp_type_str[0:2] == "83":
		return 1,"3W"
	elif comp_type_str[0:2] == "84":
		return 1,"4W"
	elif comp_type_str[0:2] == "14":
		return 1,"CR"
	elif comp_type_str[0:2] == "13":
		return 1,"TW"	
	elif (comp_type_str[0:3] == "122") | (comp_type_str[0:2] == "42"):
		return 1,"EL"	
	elif (comp_type_str[0:2] == "32") | (comp_type_str[0:2] == "35"):
		return 1,"VA"
	elif comp_type_str[0:2] == "33":
		return 1,"3W"
	elif comp_type_str[0:2] == "34":
		return 1,"4W"
	else:
		return 0," "

#								 *** Sub-13 Function ***

def Get_conn_details(pipeline_name,part_id,component_type,part_type,node_array,final_node_numbers):
	conn_ids_array=[]
	project_name,model_name=pipeline_name.split("-",1)	
	dexstring="PIPE('" + project_name + "').PIPMODEL('" + model_name + "').PART(" + str(part_id) + ").NCON"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type ==1:
		no_conns=kcs_dex.get_int()
	else:

		no_conns=0

	i=1
	conn_str=""
	conn_node_numbers_array=[]

	while i <= no_conns :
		point=KcsPoint3D.Point3D()
		kcs_pipe.pipe_activate(KcsPipeName.PipeName(model_name))  #		This statement is added to work with TRIBON M3 On  5th- 9th may 2008 		 
		conn_cordinates=kcs_pipe.part_conn_coord_get(part_id,i,point)
		exist,node_number=Is_Point_Exist(point,node_array)					# Sub-14 Function
		if exist == "no":
			try:
				connected_part=kcs_pipe.part_conn_part_get(part_id,i) 
				node_number=final_node_numbers[1]+1
				final_node_numbers[1]=node_number
			except:
				node_number=final_node_numbers[0]+1

				final_node_numbers[0]=node_number

			node_array[0].append(node_number)
			node_array[1].append('%0.2f'%point.X)
			node_array[2].append('%0.2f'%point.Y)
			node_array[3].append('%0.2f'%point.Z)



		conn_node_numbers_array.append(node_number)
		i=i+1

	component_type_str=str(component_type)

	if ( (part_type == 4) | (component_type_str[:3]=="122") | (component_type_str[:3]=="130") | (component_type_str[:3]=="140") | (component_type_str[:3]=="152") | (component_type_str[:3]=="330") | (component_type_str[:3]=="340") | (component_type_str[:3]=="830") | (component_type_str[:3]=="840") | (component_type_str[:2]=="11") | (component_type_str[:2]=="21") |(component_type_str[:2]=="31") ):

		point=KcsPoint3D.Point3D()
		dexstring="PIPE('" + project_name + "').PIPMODEL('" + model_name + "').PART(" + str(part_id) + ").NODE(0).POINT"
		kcs_dex.extract(dexstring)
		type = kcs_dex.next_result()
		if type == 4:
			point.X,point.Y,point.Z=kcs_dex.get_reavec3d()
		exist,node_number=Is_Point_Exist(point,node_array)					# Sub-14 Function
		if exist == "no":
			if ( (component_type_str[:2]=="11") | (component_type_str[:2]=="21") |(component_type_str[:2]=="31") ):
				node_number=final_node_numbers[1]+1
				final_node_numbers[1]=node_number
			else:
				node_number=final_node_numbers[2]+1
				final_node_numbers[2]=node_number
			node_array[0].append(node_number)
			node_array[1].append('%0.2f'%point.X)


			node_array[2].append('%0.2f'%point.Y)
			node_array[3].append('%0.2f'%point.Z)

		conn_node_numbers_array.append(node_number)

	if component_type_str == "1522" :

		point1=KcsPoint3D.Point3D()
		dexstring="PIPE('" + project_name + "').PIPMODEL('" + model_name + "').PART(" + str(part_id) + ").NODE(1).POINT"
		kcs_dex.extract(dexstring)
		type = kcs_dex.next_result()
		if type == 4:
			point1.X,point1.Y,point1.Z=kcs_dex.get_reavec3d()
		exist,node_number=Is_Point_Exist(point1,node_array)					# Sub-14 Function
		if exist == "no":
			node_number=final_node_numbers[2]+1
			final_node_numbers[2]=node_number
			node_array[0].append(node_number)

			node_array[1].append('%0.2f'%point1.X)
			node_array[2].append('%0.2f'%point1.Y)
			node_array[3].append('%0.2f'%point1.Z)
		conn_node_numbers_array.append(node_number)

		point2=KcsPoint3D.Point3D()
		point2.X=(point.X + point1.X)/2
		point2.Y=(point.Y + point1.Y)/2
		point2.Z=(point.Z + point1.Z)/2
		exist,node_number=Is_Point_Exist(point2,node_array)					# Sub-14 Function
		if exist == "no":
			node_number=final_node_numbers[1]+1
			final_node_numbers[1]=node_number
			node_array[0].append(node_number)
			node_array[1].append('%0.2f'%point2.X)
			node_array[2].append('%0.2f'%point2.Y)
			node_array[3].append('%0.2f'%point2.Z)
		conn_node_numbers_array.append(node_number)

		conn_str=str(conn_node_numbers_array[0]) + "," + str(conn_node_numbers_array[4]) + "," + str(conn_node_numbers_array[2])
		conn_ids_array.append(conn_str)

		conn_str=str(conn_node_numbers_array[4]) + "," + str(conn_node_numbers_array[1]) + "," + str(conn_node_numbers_array[3])
		conn_ids_array.append(conn_str)

	else:
		for node_number in conn_node_numbers_array:
			if conn_str =='':
				conn_str=conn_str + str(node_number)
			else:
				conn_str=conn_str + "," + str(node_number)
		conn_ids_array.append(conn_str)

	del conn_node_numbers_array
	return no_conns,conn_ids_array,node_array

#								 *** Sub-14 Function ***

def Is_Point_Exist(point,node_array):
	number_of_points_node_array=len(node_array[0])
	if number_of_points_node_array == 0:
		return "no",0
	x=point.X
	y=point.Y
	z=point.Z	

	for i in range(number_of_points_node_array) :
		x1=float(node_array[1][i])
		y1=float(node_array[2][i])
		z1=float(node_array[3][i])
		diff_x= abs(x-x1)
		diff_y= abs(y-y1)
		diff_z= abs(z-z1)
		if ((diff_x<1) & (diff_y<1) & (diff_z<1)):
			return "yes",node_array[0][i]
	return "no",0

#								 *** Sub-15 Function ***

def line_1(f,short_code,comp_id,spec,conn_ids_str):
	str1=" "
	str1=str1 + short_code + "," + comp_id + "," + spec + ", ,CODE0," + conn_ids_str
	f.write(str1+"\n")

#								 *** Sub-16 Function ***

def line_2(f,short_code,comp_id,comp_name,p):
	str1=" MPROP,"
	str1=str1 + short_code + "," + comp_id + "," + str(p) + ","
	dexstring="COM('" + comp_name + "').GEN_PR.MTRL_CODE"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type == 1:
		material_code=kcs_dex.get_int()
	else:
		material_code = 1

	if material_code == 3 :
		material_code_str = "A312-TP304" 
	elif material_code == 4 :
		material_code_str = "B43-C23000"
	elif material_code == 5 | material_code == 8 :
		material_code_str = "B241-A96061-T6"
	elif material_code == 6 :
		material_code_str = "MONEL-B165"
	else:
		material_code_str = "A53-A"

	dexstring="COM('" + comp_name + "').GEN_PR.WEI"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type == 2:
		dry_weight=kcs_dex.get_real()
	else:
		dry_weight = 0.0

	dry_weight_str='%0.3f'%(dry_weight)
	wet_weight='0.00'
	IF_center='0.0'
	symbol_id='0.0'
	fitting='0'
	insulation_weight='0.00'
	str1=str1 + material_code_str + "," + dry_weight_str + "," + wet_weight + "," + IF_center + "," + symbol_id + "," + fitting + "," + insulation_weight
	
	f.write(str1 + "\n")

#								 *** Sub-17 Function ***

def line_3(f,short_code,comp_id,comp_name,conn_ids_str,node_array):
	str1=" MPROP,"
	str1=str1 + short_code + "," + comp_id + ",2,"
	if short_code == "EL":
		bend_radius,bend_angle= Get_bend_details(conn_ids_str,node_array)		# Sub-18 Function
		bend_radius_str='%0.3f'%(bend_radius)
		bend_angle_str='%0.3f'%(bend_angle)
		miter_j=0
		miter_l=0
		str1=str1 + bend_radius_str + "," + bend_angle_str + "," + str(miter_j) + "," + str(miter_l)
		f.write(str1 + "\n")	

	elif ( (short_code == "ER") | (short_code == "RD") ):
		line_2(f,short_code,comp_id,comp_name,2)						# Sub-16 Function

	elif ( (short_code == "VA") | (short_code == "3W") | (short_code == "4W") ):
		str1 = str1 + "0.00,0.00,0.00"
		f.write(str1 + "\n")

	elif short_code == "TW" :
		str1 = str1 + "0.00,0.00,0.00"
		f.write(str1 + "\n")


#								 *** Sub-18 Function ***
	
def Get_bend_details(conn_ids_str,node_array):

	node1_str,node2_str,node3_str=conn_ids_str.split(",")
	node1=int(node1_str)
	node2=int(node2_str)
	node3=int(node3_str)

	i=0
	while i < len(node_array[0]) :
		if node1 == node_array[0][i]:
			x1=float(node_array[1][i])
			y1=float(node_array[2][i])
			z1=float(node_array[3][i])
		if node2 == node_array[0][i]:
			x2=float(node_array[1][i])
			y2=float(node_array[2][i])
			z2=float(node_array[3][i])
		if node3 == node_array[0][i]:
			x3=float(node_array[1][i])
			y3=float(node_array[2][i])
			z3=float(node_array[3][i])
		i=i+1
	
	d1= math.sqrt(math.pow((x1-x3),2) + math.pow((y1-y3),2) + math.pow((z1-z3),2) )
	l1= (x1-x3)/d1
	m1= (y1-y3)/d1
	n1= (z1-z3)/d1

	d2= math.sqrt(math.pow((x2-x3),2) + math.pow((y2-y3),2) + math.pow((z2-z3),2) )
	l2= (x2-x3)/d2
	m2= (y2-y3)/d2
	n2= (z2-z3)/d2

	bend_angle = math.acos((l1*l2 + m1*m2 + n1*n2))*180 /math.pi

	bend_angle_rad = (180.00 - bend_angle) * math.pi / 180.00
	dis=d2
	if d1 < d2 :
		dis = d1

	bend_radius = abs(dis/(math.tan(bend_angle_rad/2)))

	return bend_radius, bend_angle

#								 *** Sub-19 Function ***

def line_conn(f,short_code,comp_id,comp_name,conn,seg_id):
	str1=" MPROP,"
	str1=str1 + short_code + "," + comp_id + ","

	nominal_dia=0
	pipe_outer_dia=0.0
	wall_thickness=0.0


	dexstring="COM('" + comp_name + "').PIPE.CONNECTION(" + str(conn+1) + ").NOMINALDIAMETER"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type == 1:
		nominal_dia=kcs_dex.get_int()
	
	dexstring="COM('" + comp_name + "').PIPE.CONNECTION(" + str(conn+1) + ").PIPEDIAMETER"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type == 2 :
		pipe_outer_dia=kcs_dex.get_real()
		
	dexstring="COM('" + comp_name + "').PIPE.CONNECTION(" + str(conn+1) + ").WALLT"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type == 2:
		wall_thickness=kcs_dex.get_real()

	if wall_thickness==0:
		dexstring="COM('" + comp_name + "').PIPE.CONNECTION(1).WALLT"
		kcs_dex.extract(dexstring)
		type = kcs_dex.next_result()
		if type == 2:
			wall_thickness=kcs_dex.get_real()

	if ((wall_thickness==0) | (pipe_outer_dia==0.0)) :
		wall_thickness=0
		pipe_outer_dia=0
	else:
		nominal_dia=0

	pipe_outer_dia_str= '%0.4f'%(pipe_outer_dia)
	wall_thickness_str= '%0.4f'%(wall_thickness)

	dexstring="COM('" + comp_name + "').PIPE.CONNECTION(" + str(conn+1) + ").FLA"

	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type == 1:
		conn_code1=kcs_dex.get_int()
	else:
		conn_code1 = 5

	dexstring="COM('" + comp_name + "').PIPE.CONNECTION(" + str(conn+1) + ").THR"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type == 1:
		conn_code2=kcs_dex.get_int()
	else:
		conn_code2= 6

	connection='%d%d'%(conn_code1,conn_code2)
	if( (connection[0] == "0") | (connection[0] == "1") ):
		if connection[1] == "0" :
			connection_str = "BWD"
		else:
			connection_str = "SFA"
	elif connection[0] == "5" :
		connection_str = "OPEN"
	else:
		connection_str = "FAA"

	dexstring="COM('" + comp_name + "').PIPE.CONNECTION(" + str(conn+1) + ").PRES"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type == 3:
		rating=kcs_dex.get_string()
	else:
		rating="0"


	str2=str1 + str(conn+3) + "," + str(nominal_dia) + "," + pipe_outer_dia_str + "," + connection_str + "," + wall_thickness_str + "," + rating + "," + str(seg_id)


	f.write(str2 + "\n")

	str1=str1 +	"4," + str(nominal_dia) + "," + pipe_outer_dia_str + "," + connection_str + "," + wall_thickness_str + "," + rating + "," + str(seg_id)

	dexstring="COM('" + comp_name + "').TYPE"
	kcs_dex.extract(dexstring)
	type = kcs_dex.next_result()
	if type == 1:
		component_type=kcs_dex.get_int()

	if ((component_type == 1101) | (component_type == 1102) | (component_type == 2101) | (component_type == 3101)):
		f.write(str1 + "\n")


#**********************************************************************************************************************
								# Main function 

app = DemoApp(0)
try:
	wxEndBusyCursor()
except:
	print "no cursor is busy"

select_choice(1,"Select Through System Names","Select Through Graphics")
app.MainLoop()
